//+------------------------------------------------------------------+
//|                                                     UltraWPR.mq5 |
//|                                   Copyright  2008, dm34@mail.ru | 
//|                                    http://www.fxexpert.ru/forum/ | 
//+------------------------------------------------------------------+
//---  
#property copyright "Copyright  2008, dm34@mail.ru"
//---    
#property link "http://www.fxexpert.ru/forum/"
//---   
#property version   "1.00"
//---     
#property indicator_separate_window
//---        
#property indicator_buffers 2
//---    
#property indicator_plots   1
//+-----------------------------------+ 
//|                 |
//+-----------------------------------+ 
#define RESET 0 //        
//+-----------------------------------+
//|          |
//+-----------------------------------+
//---        
#property indicator_type1   DRAW_FILLING
//---           
#property indicator_color1  Lime, Magenta
//---   
#property indicator_label1 "Ultra WPR"
//+-----------------------------------+
//|    CXMA             |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//---    CXMA   SmoothAlgorithms.mqh
CXMA XMA[];
//+-----------------------------------+
//|             |
//+-----------------------------------+  
enum WIDTH
  {
   Width_1=1, // 1
   Width_2,   // 2
   Width_3,   // 3
   Width_4,   // 4
   Width_5    // 5
  };
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum STYLE
  {
   SOLID_,       //  
   DASH_,        //  
   DOT_,         //  
   DASHDOT_,     // - 
   DASHDOTDOT_   // -    
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int WPR_Period=13;                    //   WPR
input Smooth_Method W_Method=MODE_JJMA;     //  
input int StartLength=3;                    //                       
input int WPhase=100;                       //  
//--- WPhase:  JJMA    -100 ... +100,     ;
//--- WPhase:  VIDIA   CMO,  AMA    
input uint Step=5;                          //   
input uint StepsTotal=10;                   //   
input Smooth_Method SmoothMethod=MODE_JJMA; //  
input int SmoothLength=3;                   //                      
input int SmoothPhase=100;                  //   (-100..+100)
input uint UpLevel=80;                      //   ( %)
input uint DnLevel=20;                      //   ( %)
input color UpLevelsColor=Blue;             //   
input color DnLevelsColor=Blue;             //   
input STYLE Levelstyle=DASH_;               //  
input WIDTH  LevelsWidth=Width_1;           //  
//+----------------------------------------------+

//---   ,   
//---      
double BullsBuffer[];
double BearsBuffer[];
//---          WPR
int period[];
//---         WPR
double xwpr0[],xwpr1[];
//---      
int WPR_Handle;
//---      
uint StTot1,StTot2;
int min_rates_total,min_rates_wpr,min_rates_xma;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//---     
   int size=int(StepsTotal+3);
   if(ArrayResize(XMA,size)<size) Print("      XMA[]");
   size-=2;
   if(ArrayResize(xwpr0,size)<size) Print("      xwpr0[]");
   if(ArrayResize(xwpr1,size)<size) Print("      xwpr1[]");
   if(ArrayResize(period,size)<size) Print("      period[]");
//---  
   for(int sm=int(StepsTotal); sm>=0 && !IsStopped(); sm--) period[sm]=int(StartLength+sm*Step);
//---       
   XMA[0].XMALengthCheck("StartLength", StartLength);
   XMA[0].XMAPhaseCheck("WPhase", WPhase, W_Method);
   XMA[0].XMALengthCheck("SmoothLength", SmoothLength);
   XMA[0].XMAPhaseCheck("SmoothPhase", SmoothPhase, SmoothMethod);
//---     
   min_rates_wpr=WPR_Period;
   min_rates_xma=min_rates_wpr+XMA[0].GetStartBars(W_Method,StartLength+Step*StepsTotal,WPhase)+1;
   min_rates_total=min_rates_xma+XMA[0].GetStartBars(SmoothMethod,SmoothLength,SmoothPhase);
   StTot1=StepsTotal+1;
   StTot2=StepsTotal+2;
//---    WPR
   WPR_Handle=iWPR(NULL,0,WPR_Period);
   if(WPR_Handle==INVALID_HANDLE)
     {
      Print("      WPR");
      return(INIT_FAILED);
     }
//---    BullsBuffer   
   SetIndexBuffer(0,BullsBuffer,INDICATOR_DATA);
//---       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---       
   ArraySetAsSeries(BullsBuffer,true);
//---    BearsBuffer   
   SetIndexBuffer(1,BearsBuffer,INDICATOR_DATA);
//---       2  min_rates_total
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---       
   ArraySetAsSeries(BearsBuffer,true);
//---      
   string shortname="Ultra WPR";
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,2);
//---     
   IndicatorSetInteger(INDICATOR_LEVELS,2);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,StepsTotal*UpLevel/100);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,UpLevelsColor);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,Levelstyle);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,0,LevelsWidth);
//---
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,StepsTotal*DnLevel/100);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,DnLevelsColor);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,Levelstyle);
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,1,LevelsWidth);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(BarsCalculated(WPR_Handle)<rates_total || rates_total<min_rates_total) return(RESET);
//---    
   int to_copy,limit,bar,maxbar1,maxbar2;
   double WPR[],upsch,dnsch;
//---    maxbar   XMASeries()
   maxbar1=rates_total-1-min_rates_wpr;
   maxbar2=rates_total-1-min_rates_xma;
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=maxbar1; //      
   else limit=rates_total-prev_calculated; //      
//---   
   to_copy=limit+2;
//---      
   if(CopyBuffer(WPR_Handle,0,0,to_copy,WPR)<=0) return(RESET);
//---         
   ArraySetAsSeries(WPR,true);
//---    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      for(int sm=int(StepsTotal); sm>=0 && !IsStopped(); sm--)
         xwpr0[sm]=XMA[sm].XMASeries(maxbar1,prev_calculated,rates_total,W_Method,WPhase,period[sm],WPR[bar],bar,true);

      if(bar>maxbar2)
        {
         if(bar) ArrayCopy(xwpr1,xwpr0,0,0,WHOLE_ARRAY);
         continue;
        }
      upsch=0;
      dnsch=0;
      for(int sm=int(StepsTotal); sm>=0 && !IsStopped(); sm--)
         if(xwpr0[sm]>xwpr1[sm]) upsch++;
      else                    dnsch++;

      BullsBuffer[bar]=XMA[StTot1].XMASeries(maxbar2,prev_calculated,rates_total,SmoothMethod,SmoothPhase,SmoothLength,upsch,bar,true);
      BearsBuffer[bar]=XMA[StTot2].XMASeries(maxbar2,prev_calculated,rates_total,SmoothMethod,SmoothPhase,SmoothLength,dnsch,bar,true);

      if(bar) ArrayCopy(xwpr1,xwpr0,0,0,WHOLE_ARRAY);
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
